unit SliderTest;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  SliderComponent,LclIntf;

type

  { TForm1 }

  TForm1 = class(TForm)
    BackgroundColor: TButton;
    BorderColor: TButton;
    BorderWidt: TButton;
    Slider_1: TButton;
    Slider_2: TButton;
    Slider_3: TButton;
    ShowTextLabel: TButton;
    SliderComponent1: TSliderComponent;
    TextLabelPosition: TButton;
    TextLaAutoCount: TButton;
    TextLaInPercent: TButton;
    PrefixSuffix: TButton;
    ScaleOtherSide: TButton;
    ShowBigMark: TButton;
    BigMarkInterval: TButton;
    BigMarkColor: TButton;
    BigMarkSize: TButton;
    ShowScale: TButton;
    ScaleInterval: TButton;
    ScaleLineColor: TButton;
    ScaleMarkColor: TButton;
    ScaleStyle: TButton;
    TrackColor: TButton;
    ShowSelRange: TButton;
    SelColor: TButton;
    ShowExtraColor: TButton;
    ExtraColor: TButton;
    IndicatorVisible: TButton;
    IndicatorColor: TButton;
    IndicatorFontColor: TButton;
    FocusColor1: TButton;
    FocusColor2: TButton;
    MarkVisible: TButton;
    MarkPosition: TButton;
    Mark2Visible: TButton;
    Mark2Position: TButton;
    MarkColor: TButton;
    KnobStyle: TButton;
    ShowKnob_2: TButton;
    Knob2Color: TButton;
    ShowKnob3: TButton;
    Knob3Color: TButton;
    KnobColor: TButton;
    KnobLookColor: TButton;
    ColorDialog1: TColorDialog;
    Label1: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    RadioGroup4: TRadioGroup;
    procedure BackgroundColorClick(Sender: TObject);
    procedure BigMarkIntervalClick(Sender: TObject);
    procedure BigMarkSizeClick(Sender: TObject);
    procedure BorderColorClick(Sender: TObject);
    procedure BorderWidtClick(Sender: TObject);
    procedure BigMarkColorClick(Sender: TObject);
    procedure PrefixSuffixClick(Sender: TObject);
    procedure Slider_1Click(Sender: TObject);
    procedure Slider_2Click(Sender: TObject);
    procedure Slider_3Click(Sender: TObject);
    procedure TextLaInPercentClick(Sender: TObject);
    procedure ExtraColorClick(Sender: TObject);
    procedure FocusColor1Click(Sender: TObject);
    procedure FocusColor2Click(Sender: TObject);
    procedure IndicatorColorClick(Sender: TObject);
    procedure IndicatorFontColorClick(Sender: TObject);
    procedure IndicatorVisibleClick(Sender: TObject);
    procedure Panel3Click(Sender: TObject);
    procedure ScaleIntervalClick(Sender: TObject);
    procedure Mark2PositionClick(Sender: TObject);
    procedure Mark2VisibleClick(Sender: TObject);
    procedure MarkColorClick(Sender: TObject);
    procedure MarkPositionClick(Sender: TObject);
    procedure Knob2ColorClick(Sender: TObject);
    procedure Knob3ColorClick(Sender: TObject);
    procedure KnobLookColorClick(Sender: TObject);
    procedure KnobColorClick(Sender: TObject);
    procedure KnobStyleClick(Sender: TObject);
    procedure MarkVisibleClick(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure RadioGroup3Click(Sender: TObject);
    procedure RadioGroup4Click(Sender: TObject);
    procedure ScaleLineColorClick(Sender: TObject);
    procedure ScaleMarkColorClick(Sender: TObject);
    procedure ScaleOtherSideClick(Sender: TObject);
    procedure ScaleStyleClick(Sender: TObject);
    procedure SelColorClick(Sender: TObject);
    procedure ShowBigMarkClick(Sender: TObject);
    procedure ShowExtraColorClick(Sender: TObject);
    procedure ShowKnob3Click(Sender: TObject);
    procedure ShowKnob_2Click(Sender: TObject);
    procedure ShowScaleClick(Sender: TObject);
    procedure ShowSelRangeClick(Sender: TObject);
    procedure ShowTextLabelClick(Sender: TObject);
    procedure SliderComponent1Change(const Count: integer);
    procedure TextLaAutoCountClick(Sender: TObject);
    procedure TextLabelPositionClick(Sender: TObject);
    procedure TrackColorClick(Sender: TObject);
  private

  public

  end;

var
  Form1    : TForm1;
  bw       : integer = 1;
  KS       : integer;
  po       : integer;
implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.SliderComponent1Change(const Count: integer);
begin
 Label1.Caption:=' Value: '+inttostr(count);
 with SliderComponent1.MultiKnob do
  begin
   if ShowKnob2 then Label1.Caption:=' Value: '+inttostr(count)+'  Value2: '+inttostr(PosKnob2);
   if ShowKnob3 then Label1.Caption:=' Value: '+inttostr(count)+'  Value3: '+inttostr(PosKnob3);
   if ShowKnob2 and ShowKnob3 then Label1.Caption:=' Value: '+inttostr(count)+
    '  Value2: '+inttostr(PosKnob2)+'  Value3: '+inttostr(PosKnob3);

  end;
end;

procedure TForm1.TextLaAutoCountClick(Sender: TObject);
begin
 with SliderComponent1.TextLabel.FillIn do
  if AutoCount then AutoCount:=false else AutoCount:=true;
 SliderComponent1.TextLabel.Caption:='TextLabel';
end;

procedure TForm1.TextLabelPositionClick(Sender: TObject);
begin
  inc(po);
  case po of
   0: SliderComponent1.TextLabel.Position:=poBottom;
   1: SliderComponent1.TextLabel.Position:=poLeft;
   2: SliderComponent1.TextLabel.Position:=poTop;
   3: SliderComponent1.TextLabel.Position:=poRight;
  end;
  if po=3 then po:=-1;
end;

procedure TForm1.TrackColorClick(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.Track.TrackColor:=(colordialog1.Color);
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);  //Wertebereich einstellen
begin
 with SliderComponent1 do
  begin
   if RadioGroup1.ItemIndex =0 then  //Positiv
    begin
     RangeMin :=   0;
     RangeMax := 500;
     Position :=   0;
     Mark.MarkPosition:=100;
     Mark.Mark2Position:=200;
     Track.ExtraRangeMin:=450;
     Track.ExtraRangeMax:=500;
    end;//0
   if RadioGroup1.ItemIndex =1 then  //Negativ
    begin
     RangeMin:= -500;
     RangeMax:=    0;
     Position :=   0;
     Mark.MarkPosition:=-100;
     Mark.Mark2Position:=-200;
     Track.ExtraRangeMin:=-450;
     Track.ExtraRangeMax:=-500;
    end;//1
   if RadioGroup1.ItemIndex =2 then  //Positiv/Negativ
    begin
     RangeMin:= -250;
     RangeMax:=  250;
     Position :=   0;
     Mark.MarkPosition:=100;
     Mark.Mark2Position:=-100;
     Track.ExtraRangeMin:=-200;
     Track.ExtraRangeMax:=200;
    end;//2
  end;//with
end;

procedure TForm1.MarkVisibleClick(Sender: TObject);
begin
 with SliderComponent1.Mark do
  begin
   if MarkVisible then MarkVisible:=false else MarkVisible:=true;
   MarkPosition:= 100;
  end;
end;

procedure TForm1.KnobLookColorClick(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.KnobLookColor:=(colordialog1.Color);
end;

procedure TForm1.KnobColorClick(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.KnobColor:=(colordialog1.Color);
end;

procedure TForm1.KnobStyleClick(Sender: TObject);
begin
 inc(KS);
 case KS of
  0: SliderComponent1.KnobStyle:= ksCircle;
  1: SliderComponent1.KnobStyle:= ksRectangle;
  2: SliderComponent1.KnobStyle:= ksRoundrect;
  3: SliderComponent1.KnobStyle:= ksArrowUp;   //right
  4: SliderComponent1.KnobStyle:= ksArrowDown; //left
 end;//case
 if KS=4 then ks:=-1;
end;

procedure TForm1.BackgroundColorClick(Sender: TObject);
begin
  if colordialog1.Execute then
  SliderComponent1.BackgroundColor:=(colordialog1.Color);
end;

procedure TForm1.BigMarkIntervalClick(Sender: TObject);
begin
 with SliderComponent1.Scale do
  begin
   BigMarkInterval:= BigMarkInterval*2;
   if BigMarkInterval>100 then BigMarkInterval:=25;
  end;
end;

procedure TForm1.BigMarkSizeClick(Sender: TObject);
begin
 with SliderComponent1.Scale do
  begin
   BigMarkSize:=BigMarkSize+0.5;
   if BigMarkSize=3 then BigMarkSize:=1.5;
  end;
end;

procedure TForm1.BorderColorClick(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.BorderColor :=(colordialog1.Color);
end;

procedure TForm1.BorderWidtClick(Sender: TObject);
begin
 if bw= 5 then bw:=0;
 inc(bw);
 SliderComponent1.BorderWidth:=bw;
 BorderWidt.Caption:='BorderWidth('+inttostr(bw)+')';

end;

procedure TForm1.BigMarkColorClick(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.Scale.BigMarkColor :=(colordialog1.Color);
end;

procedure TForm1.PrefixSuffixClick(Sender: TObject);
begin
 with SliderComponent1.TextLabel.FillIn do
  begin
   if not Percent then
    begin
     Prefix:='Wert: ';
     Suffix:=' Inkremente';
    end//NotPercent
    else
    begin
     Prefix:='Wert: ';
     Suffix:=' in Prozent';
    end;//else
  end;//with
end;

procedure TForm1.Slider_1Click(Sender: TObject);
begin
 Panel1.Color:=rgb(55,55,55);

 with SliderComponent1 do
   begin
    height:=30;
    TextLabel.Visible:=false;
    BackgroundColor:= clwhite;
    BorderColor    := clwhite;
    Track.TrackColor:= rgb(55,55,55);
    FocusColor1:=rgb(55,55,55);
    FocusColor2:=rgb(250,110,10);
    KnobStyle:=ksroundrect;
    KnobLook:=klRipped;
    KnobColor:=rgb(55,55,55);
    KnobLookColor:= rgb(255,140,10);
    Track.SelColor:=clsilver;
    Scale.ShowScale:=true;
    Scale.Interval:=20;
    Scale.ScaleStyle:=ssDash;
    Scale.LineColor:=clblack;
    Scale.MarkColor:=clblack;
    Scale.OtherSide:=false;
   end;
end;

procedure TForm1.Slider_2Click(Sender: TObject);
begin
 Panel1.Color:=rgb(190,190,190);
 with SliderComponent1 do
   begin
    BackgroundColor:= rgb(90,90,90);
    BorderColor    := rgb(90,90,90);
    KnobStyle:=ksCircle;
    KnobLook:=klRipped;
    KnobColor:=clNavy;
    KnobLookColor:=clwhite;
    TextLabel.Visible:=true;
    TextLabel.Color:=rgb(190,190,190);
    TextLabel.FillIn.AutoCount:=true;
    TextLabel.FillIn.Prefix:='  Zoom: ';
    TextLabel.FillIn.Suffix:=' %';
    TextLabel.FillIn.Percent:=true;
    Scale.ShowScale:=false;
    height:=44;
   end;
end;

procedure TForm1.Slider_3Click(Sender: TObject);
begin
 Panel1.Color:=clwhite;

 with SliderComponent1 do
   begin
    height:=30;
    TextLabel.Visible:=false;
    BackgroundColor:= rgb(0,0,255);
    BorderColor    := rgb(255,0,255);
    KnobStyle:=ksArrowUp;
    KnobLook:=klRipped;
    KnobColor:=clNavy;
    KnobLookColor:= rgb(255,0,255);
    Scale.ShowScale:=true;
    Scale.Interval:=25;
    Scale.LineColor:=rgb(255,0,255);
    Scale.MarkColor:=cllime;
    Scale.OtherSide:=true;
    Scale.ScaleStyle:=ssCircle;
   end;
end;

procedure TForm1.TextLaInPercentClick(Sender: TObject);
begin
 with SliderComponent1.TextLabel.FillIn do
  if Percent then Percent:=false else Percent:=true;
 PrefixSuffixClick(TextLaInPercent);
end;

procedure TForm1.ExtraColorClick(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.Track.ExtraColor :=(colordialog1.Color);
end;

procedure TForm1.FocusColor1Click(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.FocusColor1 :=(colordialog1.Color);
 SliderComponent1.SetFocus;
end;

procedure TForm1.FocusColor2Click(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.FocusColor2 :=(colordialog1.Color);
 SliderComponent1.SetFocus;
end;

procedure TForm1.IndicatorColorClick(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.Indicator.IndicatorColor :=(colordialog1.Color);
end;

procedure TForm1.IndicatorFontColorClick(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.Indicator.IndicatorFontColor :=(colordialog1.Color);
end;

procedure TForm1.IndicatorVisibleClick(Sender: TObject);
begin
 with SliderComponent1.Indicator do
  begin
   if IndicatorVisible then IndicatorVisible:=false else IndicatorVisible:=true;
  end;
end;

procedure TForm1.Panel3Click(Sender: TObject);
begin

end;

procedure TForm1.ScaleIntervalClick(Sender: TObject);
begin
 with SliderComponent1.Scale do
  begin
   Interval:= Interval+10;
   if Interval = 40 then Interval:=50;
   if Interval=60 then Interval:=10;
  end;
end;

procedure TForm1.Mark2PositionClick(Sender: TObject);
begin
 with SliderComponent1.Mark do
  begin
   if Mark2Position=SliderComponent1.RangeMax then Mark2Position:=SliderComponent1.RangeMin ;
   Mark2Position:=Mark2Position+5;
  end;
end;

procedure TForm1.Mark2VisibleClick(Sender: TObject);
begin
 with SliderComponent1.Mark do
  begin
   if Mark2Visible then Mark2Visible:=false else Mark2Visible:=true;
   Mark2Position:= 200;
  end;
end;

procedure TForm1.MarkColorClick(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.Mark.MarkColor :=(colordialog1.Color);
end;

procedure TForm1.MarkPositionClick(Sender: TObject);
begin
 with SliderComponent1.Mark do
  begin
   if MarkPosition=SliderComponent1.RangeMax then MarkPosition:=SliderComponent1.RangeMin ;
   MarkPosition:=MarkPosition+5;
  end;
end;

procedure TForm1.Knob2ColorClick(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.MultiKnob.ColorKnob2 :=(colordialog1.Color);
end;

procedure TForm1.Knob3ColorClick(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.MultiKnob.ColorKnob3 :=(colordialog1.Color);
end;

procedure TForm1.RadioGroup2Click(Sender: TObject); //Orientation
begin
 with SliderComponent1 do
  begin
   if RadioGroup2.ItemIndex =0 then  //Horizontal
    begin
     Panel1.Left  :=  20;
     Panel1.Top   :=  10;
     Panel1.Width := 540;
     Panel1.Height:=  90;
     left := 20;
     top  := 30;
     Orientation:=scHorizontal;
    end;//0
   if RadioGroup2.ItemIndex =1 then  //Verical
    begin
     Panel1.Left  :=  20;
     Panel1.Top   :=  10;
     Panel1.Width :=  90;
     Panel1.Height:= 540;
     left := 30;
     top  := 20;
     Orientation:=scVertical;
    end;//1
  end;//with
end;

procedure TForm1.RadioGroup3Click(Sender: TObject); //Reversed
begin
 with SliderComponent1 do
  begin
   if RadioGroup3.ItemIndex =0 then Reversed:=false;
   if RadioGroup3.ItemIndex =1 then Reversed:=true;
  end;//with
end;

procedure TForm1.RadioGroup4Click(Sender: TObject);
begin
 with SliderComponent1 do
  begin
   if RadioGroup4.ItemIndex =0 then KnobLook:=klNormal;
   if RadioGroup4.ItemIndex =1 then KnobLook:=klRipped;
  end;//with
end;

procedure TForm1.ScaleLineColorClick(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.Scale.LineColor :=(colordialog1.Color);
end;

procedure TForm1.ScaleMarkColorClick(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.Scale.MarkColor :=(colordialog1.Color);
end;

procedure TForm1.ScaleOtherSideClick(Sender: TObject);
begin
 with SliderComponent1.Scale do
  if OtherSide then OtherSide:=false else OtherSide:=true;
end;

procedure TForm1.ScaleStyleClick(Sender: TObject);
begin
 with SliderComponent1.Scale do
  if ScaleStyle=ssCircle then ScaleStyle:=ssDash else ScaleStyle:=ssCircle;
end;

procedure TForm1.SelColorClick(Sender: TObject);
begin
 if colordialog1.Execute then
 SliderComponent1.Track.SelColor :=(colordialog1.Color);
end;

procedure TForm1.ShowBigMarkClick(Sender: TObject);
begin
 with SliderComponent1.Scale do
  begin
   if ShowBigMark then ShowBigMark:=false else ShowBigMark:=true;
   BigMarkInterval:=25;
  end;
end;

procedure TForm1.ShowExtraColorClick(Sender: TObject);
begin
 with SliderComponent1.Track do
  begin
   if ShowExtraColor then ShowExtraColor:=false else ShowExtraColor:=true;
   ExtraRangeMin:=450;
   ExtraRangeMax:=500;
  end;
end;

procedure TForm1.ShowKnob3Click(Sender: TObject);
begin
  with SliderComponent1.MultiKnob do
   begin
    if ShowKnob3 then ShowKnob3:=false else ShowKnob3:=true;
    PosKnob3 := 100;
    SliderComponent1Change(SliderComponent1.Position);
   end;//with
end;

procedure TForm1.ShowKnob_2Click(Sender: TObject);
begin
  with SliderComponent1.MultiKnob do
   begin
    if ShowKnob2 then ShowKnob2:=false else ShowKnob2:=true;
    PosKnob2 := 50;
    SliderComponent1Change(SliderComponent1.Position);
   end;//with
end;

procedure TForm1.ShowScaleClick(Sender: TObject);
begin
 with SliderComponent1.Scale do
  begin
   if ShowScale then ShowScale:=false else ShowScale:=true;
   Interval:=10;
  end;
end;

procedure TForm1.ShowSelRangeClick(Sender: TObject);
begin
 with SliderComponent1.Track do
 if ShowSelRange then ShowSelRange:=false else ShowSelRange:=true;
end;

procedure TForm1.ShowTextLabelClick(Sender: TObject);
begin
 with SliderComponent1.TextLabel do
  if Visible then Visible:=false else Visible:=true;
end;


end.

